#include <iostream>
#include <string>
#include <string_view>
using namespace std;

// ======================================================================
string palindromise(string_view s)
{
  // abcd ---> abcddcba  ou dcbaabcd ???
  // ICI : abcd ---> dcbaabcd
  
  string retour(s); // commence par recopier s

  for (char c : s)
    retour = c + retour;
  
  return retour;
}

// ======================================================================
bool est_palindrome(string_view s)
{
  if (s.size() <= 1) return true;

  // si le 1er char est égal au dernier
  if (s[0] == s[s.size() - 1]) // ou s.back()
    return est_palindrome(s.substr(1, s.size() - 2));

  return false;
}

// ===== tests ==========================================================

// pour éviter le « copié-collé » dans test() ci-dessous
void test_elementaire(string_view s) { 
  cout << '"' << s << "\" : " << est_palindrome(s);
}

// --------------------------------------------------
void test(string_view s) {          // niveau 3
// ou void test(string const& s) {  // niveau 2
// ou void test(string s) {         // niveau 1

  test_elementaire(s);
  cout << " --> ";
  test_elementaire(palindromise(s));
  cout << endl;
}

// ======================================================================
int main()
{
  test("abcd");  // non palindrome
  test("rever"); // palindrome impair
  test("elle");  // palindrome pair
  test("abcdefghfedcba"); // non palindrome, mais presque

  // cas limites
  test("");
  test("a");
  test("ab");
  test("aa");

  return 0;
}
